semigroupoids-6.0.1: Semigroupoids: Category sans id

Copyright | (C) 2011-2015 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | provisional
Portability | portable
Safe Haskell | Safe
Language | Haskell2010

Data.Semigroup.Foldable

Description

Re-exports a subset of the Data.Foldable1 module along with some additional combinators that require `Foldable1` constraints.

Synopsis

- class Foldable t => Foldable1 (t :: Type -> Type) where
  - fold1 :: Semigroup m => t m -> m
  - foldMap1 :: Semigroup m => (a -> m) -> t a -> m
  - toNonEmpty :: t a -> NonEmpty a
- intercalate1 :: (Foldable1 t, Semigroup m) => m -> t m -> m
- foldrM1 :: (Foldable1 t, Monad m) => (a -> a -> m a) -> t a -> m a
- foldlM1 :: (Foldable1 t, Monad m) => (a -> a -> m a) -> t a -> m a
- intercalateMap1 :: (Foldable1 t, Semigroup m) => m -> (a -> m) -> t a -> m
- traverse1_ :: (Foldable1 t, Apply f) => (a -> f b) -> t a -> f ()
- for1_ :: (Foldable1 t, Apply f) => t a -> (a -> f b) -> f ()
- sequenceA1_ :: (Foldable1 t, Apply f) => t (f a) -> f ()
- foldMapDefault1 :: (Foldable1 t, Monoid m) => (a -> m) -> t a -> m
- asum1 :: (Foldable1 t, Alt m) => t (m a) -> m a
- gfold1 :: (Foldable1 (Rep1 t), Generic1 t, Semigroup m) => t m -> m
- gfoldMap1 :: (Foldable1 (Rep1 t), Generic1 t, Semigroup m) => (a -> m) -> t a -> m
- gtoNonEmpty :: (Foldable1 (Rep1 t), Generic1 t) => t a -> NonEmpty a

# Documentation

class Foldable t => Foldable1 (t :: Type -> Type) where Source #

Non-empty data structures that can be folded.

Since: base-4.18.0.0

Minimal complete definition

foldMap1 | foldrMap1

Methods

fold1 :: Semigroup m => t m -> m Source #

Given a structure with elements whose type is a `Semigroup`, combine them via the semigroup's `(`<>`)` operator. This fold is right-associative and lazy in the accumulator. When you need a strict left-associative fold, use `foldMap1'` instead, with `id` as the map.

Since: base-4.18.0.0

foldMap1 :: Semigroup m => (a -> m) -> t a -> m Source #

Map each element of the structure to a semigroup, and combine the results with `(`<>`)`. This fold is right-associative and lazy in the accumulator. For strict left-associative folds consider `foldMap1'` instead.

    >>> foldMap1 (:[]) (1 :| [2, 3, 4])
    [1,2,3,4]

Since: base-4.18.0.0

toNonEmpty :: t a -> NonEmpty a Source #

`NonEmpty` list of elements of a structure, from left to right.

    >>> toNonEmpty (Identity 2)
    2 :| []

Since: base-4.18.0.0

#### Instances

Instances details

Foldable1 Complex | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => Complex m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Complex a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Complex a -> m Source #

toNonEmpty :: Complex a -> NonEmpty a Source #

maximum :: Ord a => Complex a -> a Source #

minimum :: Ord a => Complex a -> a Source #

head :: Complex a -> a Source #

last :: Complex a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Complex a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Complex a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Complex a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Complex a -> b Source #

Foldable1 First | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => First m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> First a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> First a -> m Source #

toNonEmpty :: First a -> NonEmpty a Source #

maximum :: Ord a => First a -> a Source #

minimum :: Ord a => First a -> a Source #

head :: First a -> a Source #

last :: First a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> First a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> First a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> First a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> First a -> b Source #

Foldable1 Last | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => Last m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Last a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Last a -> m Source #

toNonEmpty :: Last a -> NonEmpty a Source #

maximum :: Ord a => Last a -> a Source #

minimum :: Ord a => Last a -> a Source #

head :: Last a -> a Source #

last :: Last a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Last a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Last a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Last a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Last a -> b Source #

Foldable1 Max | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => Max m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Max a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Max a -> m Source #

toNonEmpty :: Max a -> NonEmpty a Source #

maximum :: Ord a => Max a -> a Source #

minimum :: Ord a => Max a -> a Source #

head :: Max a -> a Source #

last :: Max a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Max a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Max a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Max a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Max a -> b Source #

Foldable1 Min | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => Min m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Min a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Min a -> m Source #

toNonEmpty :: Min a -> NonEmpty a Source #

maximum :: Ord a => Min a -> a Source #

minimum :: Ord a => Min a -> a Source #

head :: Min a -> a Source #

last :: Min a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Min a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Min a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Min a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Min a -> b Source #

Foldable1 SCC | Since: containers-0.7.0

Instance details

Defined in Data.Graph

Methods

fold1 :: Semigroup m => SCC m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> SCC a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> SCC a -> m Source #

toNonEmpty :: SCC a -> NonEmpty a Source #

maximum :: Ord a => SCC a -> a Source #

minimum :: Ord a => SCC a -> a Source #

head :: SCC a -> a Source #

last :: SCC a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> SCC a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> SCC a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> SCC a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> SCC a -> b Source #

Foldable1 Tree | Folds in preorder Since: containers-0.6.7

Instance details

Defined in Data.Tree

Methods

fold1 :: Semigroup m => Tree m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Tree a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Tree a -> m Source #

toNonEmpty :: Tree a -> NonEmpty a Source #

maximum :: Ord a => Tree a -> a Source #

minimum :: Ord a => Tree a -> a Source #

head :: Tree a -> a Source #

last :: Tree a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Tree a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Tree a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Tree a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Tree a -> b Source #

Foldable1 NonEmpty | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => NonEmpty m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> NonEmpty a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> NonEmpty a -> m Source #

toNonEmpty :: NonEmpty a -> NonEmpty a Source #

maximum :: Ord a => NonEmpty a -> a Source #

minimum :: Ord a => NonEmpty a -> a Source #

head :: NonEmpty a -> a Source #

last :: NonEmpty a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> NonEmpty a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> NonEmpty a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> NonEmpty a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> NonEmpty a -> b Source #

Foldable1 Identity | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => Identity m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Identity a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Identity a -> m Source #

toNonEmpty :: Identity a -> NonEmpty a Source #

maximum :: Ord a => Identity a -> a Source #

minimum :: Ord a => Identity a -> a Source #

head :: Identity a -> a Source #

last :: Identity a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Identity a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Identity a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Identity a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Identity a -> b Source #

Foldable1 Down | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => Down m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Down a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Down a -> m Source #

toNonEmpty :: Down a -> NonEmpty a Source #

maximum :: Ord a => Down a -> a Source #

minimum :: Ord a => Down a -> a Source #

head :: Down a -> a Source #

last :: Down a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Down a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Down a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Down a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Down a -> b Source #

Foldable1 Dual | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => Dual m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Dual a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Dual a -> m Source #

toNonEmpty :: Dual a -> NonEmpty a Source #

maximum :: Ord a => Dual a -> a Source #

minimum :: Ord a => Dual a -> a Source #

head :: Dual a -> a Source #

last :: Dual a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Dual a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Dual a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Dual a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Dual a -> b Source #

Foldable1 Product | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => Product m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Product a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Product a -> m Source #

toNonEmpty :: Product a -> NonEmpty a Source #

maximum :: Ord a => Product a -> a Source #

minimum :: Ord a => Product a -> a Source #

head :: Product a -> a Source #

last :: Product a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Product a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Product a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Product a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Product a -> b Source #

Foldable1 Sum | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => Sum m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Sum a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Sum a -> m Source #

toNonEmpty :: Sum a -> NonEmpty a Source #

maximum :: Ord a => Sum a -> a Source #

minimum :: Ord a => Sum a -> a Source #

head :: Sum a -> a Source #

last :: Sum a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Sum a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Sum a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Sum a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Sum a -> b Source #

Foldable1 Par1 | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => Par1 m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Par1 a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Par1 a -> m Source #

toNonEmpty :: Par1 a -> NonEmpty a Source #

maximum :: Ord a => Par1 a -> a Source #

minimum :: Ord a => Par1 a -> a Source #

head :: Par1 a -> a Source #

last :: Par1 a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Par1 a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Par1 a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Par1 a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Par1 a -> b Source #

Foldable1 Solo | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => Solo m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Solo a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Solo a -> m Source #

toNonEmpty :: Solo a -> NonEmpty a Source #

maximum :: Ord a => Solo a -> a Source #

minimum :: Ord a => Solo a -> a Source #

head :: Solo a -> a Source #

last :: Solo a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Solo a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Solo a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Solo a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Solo a -> b Source #

Foldable1 (V1 :: Type -> Type) | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => V1 m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> V1 a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> V1 a -> m Source #

toNonEmpty :: V1 a -> NonEmpty a Source #

maximum :: Ord a => V1 a -> a Source #

minimum :: Ord a => V1 a -> a Source #

head :: V1 a -> a Source #

last :: V1 a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> V1 a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> V1 a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> V1 a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> V1 a -> b Source #

Foldable1 f => Foldable1 (Lift f) |

Instance details

Defined in Control.Applicative.Lift

Methods

fold1 :: Semigroup m => Lift f m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Lift f a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Lift f a -> m Source #

toNonEmpty :: Lift f a -> NonEmpty a Source #

maximum :: Ord a => Lift f a -> a Source #

minimum :: Ord a => Lift f a -> a Source #

head :: Lift f a -> a Source #

last :: Lift f a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Lift f a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Lift f a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Lift f a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Lift f a -> b Source #

Foldable1 ((,) a) | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => (a, m) -> m Source #

foldMap1 :: Semigroup m => (a0 -> m) -> (a, a0) -> m Source #

foldMap1' :: Semigroup m => (a0 -> m) -> (a, a0) -> m Source #

toNonEmpty :: (a, a0) -> NonEmpty a0 Source #

maximum :: Ord a0 => (a, a0) -> a0 Source #

minimum :: Ord a0 => (a, a0) -> a0 Source #

head :: (a, a0) -> a0 Source #

last :: (a, a0) -> a0 Source #

foldrMap1 :: (a0 -> b) -> (a0 -> b -> b) -> (a, a0) -> b Source #

foldlMap1' :: (a0 -> b) -> (b -> a0 -> b) -> (a, a0) -> b Source #

foldlMap1 :: (a0 -> b) -> (b -> a0 -> b) -> (a, a0) -> b Source #

foldrMap1' :: (a0 -> b) -> (a0 -> b -> b) -> (a, a0) -> b Source #

Bifoldable1 p => Foldable1 (Join p) |

Instance details

Defined in Data.Bifunctor.Join

Methods

fold1 :: Semigroup m => Join p m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Join p a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Join p a -> m Source #

toNonEmpty :: Join p a -> NonEmpty a Source #

maximum :: Ord a => Join p a -> a Source #

minimum :: Ord a => Join p a -> a Source #

head :: Join p a -> a Source #

last :: Join p a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Join p a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Join p a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Join p a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Join p a -> b Source #

Foldable1 f => Foldable1 (Ap f) | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => Ap f m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Ap f a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Ap f a -> m Source #

toNonEmpty :: Ap f a -> NonEmpty a Source #

maximum :: Ord a => Ap f a -> a Source #

minimum :: Ord a => Ap f a -> a Source #

head :: Ap f a -> a Source #

last :: Ap f a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Ap f a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Ap f a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Ap f a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Ap f a -> b Source #

Foldable1 f => Foldable1 (Alt f) | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => Alt f m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Alt f a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Alt f a -> m Source #

toNonEmpty :: Alt f a -> NonEmpty a Source #

maximum :: Ord a => Alt f a -> a Source #

minimum :: Ord a => Alt f a -> a Source #

head :: Alt f a -> a Source #

last :: Alt f a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Alt f a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Alt f a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Alt f a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Alt f a -> b Source #

Foldable1 f => Foldable1 (Rec1 f) | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => Rec1 f m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Rec1 f a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Rec1 f a -> m Source #

toNonEmpty :: Rec1 f a -> NonEmpty a Source #

maximum :: Ord a => Rec1 f a -> a Source #

minimum :: Ord a => Rec1 f a -> a Source #

head :: Rec1 f a -> a Source #

last :: Rec1 f a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Rec1 f a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Rec1 f a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Rec1 f a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Rec1 f a -> b Source #

Foldable1 (Tagged a) |

Instance details

Defined in Data.Tagged

Methods

fold1 :: Semigroup m => Tagged a m -> m Source #

foldMap1 :: Semigroup m => (a0 -> m) -> Tagged a a0 -> m Source #

foldMap1' :: Semigroup m => (a0 -> m) -> Tagged a a0 -> m Source #

toNonEmpty :: Tagged a a0 -> NonEmpty a0 Source #

maximum :: Ord a0 => Tagged a a0 -> a0 Source #

minimum :: Ord a0 => Tagged a a0 -> a0 Source #

head :: Tagged a a0 -> a0 Source #

last :: Tagged a a0 -> a0 Source #

foldrMap1 :: (a0 -> b) -> (a0 -> b -> b) -> Tagged a a0 -> b Source #

foldlMap1' :: (a0 -> b) -> (b -> a0 -> b) -> Tagged a a0 -> b Source #

foldlMap1 :: (a0 -> b) -> (b -> a0 -> b) -> Tagged a a0 -> b Source #

foldrMap1' :: (a0 -> b) -> (a0 -> b -> b) -> Tagged a a0 -> b Source #

Foldable1 f => Foldable1 (Backwards f) | Derived instance.

Instance details

Defined in Control.Applicative.Backwards

Methods

fold1 :: Semigroup m => Backwards f m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Backwards f a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Backwards f a -> m Source #

toNonEmpty :: Backwards f a -> NonEmpty a Source #

maximum :: Ord a => Backwards f a -> a Source #

minimum :: Ord a => Backwards f a -> a Source #

head :: Backwards f a -> a Source #

last :: Backwards f a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Backwards f a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Backwards f a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Backwards f a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Backwards f a -> b Source #

Foldable1 m => Foldable1 (IdentityT m) |

Instance details

Defined in Control.Monad.Trans.Identity

Methods

fold1 :: Semigroup m0 => IdentityT m m0 -> m0 Source #

foldMap1 :: Semigroup m0 => (a -> m0) -> IdentityT m a -> m0 Source #

foldMap1' :: Semigroup m0 => (a -> m0) -> IdentityT m a -> m0 Source #

toNonEmpty :: IdentityT m a -> NonEmpty a Source #

maximum :: Ord a => IdentityT m a -> a Source #

minimum :: Ord a => IdentityT m a -> a Source #

head :: IdentityT m a -> a Source #

last :: IdentityT m a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> IdentityT m a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> IdentityT m a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> IdentityT m a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> IdentityT m a -> b Source #

Foldable1 f => Foldable1 (Reverse f) | Fold from right to left.

Instance details

Defined in Data.Functor.Reverse

Methods

fold1 :: Semigroup m => Reverse f m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Reverse f a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Reverse f a -> m Source #

toNonEmpty :: Reverse f a -> NonEmpty a Source #

maximum :: Ord a => Reverse f a -> a Source #

minimum :: Ord a => Reverse f a -> a Source #

head :: Reverse f a -> a Source #

last :: Reverse f a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Reverse f a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Reverse f a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Reverse f a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Reverse f a -> b Source #

(Foldable1 f, Foldable1 g) => Foldable1 (Product f g) | It would be enough for either half of a product to be `Foldable1`. Other could be `Foldable`.

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => Product f g m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Product f g a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Product f g a -> m Source #

toNonEmpty :: Product f g a -> NonEmpty a Source #

maximum :: Ord a => Product f g a -> a Source #

minimum :: Ord a => Product f g a -> a Source #

head :: Product f g a -> a Source #

last :: Product f g a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Product f g a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Product f g a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Product f g a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Product f g a -> b Source #

(Foldable1 f, Foldable1 g) => Foldable1 (Sum f g) | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => Sum f g m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Sum f g a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Sum f g a -> m Source #

toNonEmpty :: Sum f g a -> NonEmpty a Source #

maximum :: Ord a => Sum f g a -> a Source #

minimum :: Ord a => Sum f g a -> a Source #

head :: Sum f g a -> a Source #

last :: Sum f g a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Sum f g a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Sum f g a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Sum f g a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Sum f g a -> b Source #

(Foldable1 f, Foldable1 g) => Foldable1 (f :*: g) | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => (f :*: g) m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> (f :*: g) a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> (f :*: g) a -> m Source #

toNonEmpty :: (f :*: g) a -> NonEmpty a Source #

maximum :: Ord a => (f :*: g) a -> a Source #

minimum :: Ord a => (f :*: g) a -> a Source #

head :: (f :*: g) a -> a Source #

last :: (f :*: g) a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> (f :*: g) a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> (f :*: g) a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> (f :*: g) a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> (f :*: g) a -> b Source #

(Foldable1 f, Foldable1 g) => Foldable1 (f :+: g) | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => (f :+: g) m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> (f :+: g) a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> (f :+: g) a -> m Source #

toNonEmpty :: (f :+: g) a -> NonEmpty a Source #

maximum :: Ord a => (f :+: g) a -> a Source #

minimum :: Ord a => (f :+: g) a -> a Source #

head :: (f :+: g) a -> a Source #

last :: (f :+: g) a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> (f :+: g) a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> (f :+: g) a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> (f :+: g) a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> (f :+: g) a -> b Source #

(Foldable1 f, Foldable1 g) => Foldable1 (Compose f g) | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => Compose f g m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> Compose f g a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> Compose f g a -> m Source #

toNonEmpty :: Compose f g a -> NonEmpty a Source #

maximum :: Ord a => Compose f g a -> a Source #

minimum :: Ord a => Compose f g a -> a Source #

head :: Compose f g a -> a Source #

last :: Compose f g a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> Compose f g a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> Compose f g a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> Compose f g a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> Compose f g a -> b Source #

Foldable1 g => Foldable1 (Joker g a) |

Instance details

Defined in Data.Bifunctor.Joker

Methods

fold1 :: Semigroup m => Joker g a m -> m Source #

foldMap1 :: Semigroup m => (a0 -> m) -> Joker g a a0 -> m Source #

foldMap1' :: Semigroup m => (a0 -> m) -> Joker g a a0 -> m Source #

toNonEmpty :: Joker g a a0 -> NonEmpty a0 Source #

maximum :: Ord a0 => Joker g a a0 -> a0 Source #

minimum :: Ord a0 => Joker g a a0 -> a0 Source #

head :: Joker g a a0 -> a0 Source #

last :: Joker g a a0 -> a0 Source #

foldrMap1 :: (a0 -> b) -> (a0 -> b -> b) -> Joker g a a0 -> b Source #

foldlMap1' :: (a0 -> b) -> (b -> a0 -> b) -> Joker g a a0 -> b Source #

foldlMap1 :: (a0 -> b) -> (b -> a0 -> b) -> Joker g a a0 -> b Source #

foldrMap1' :: (a0 -> b) -> (a0 -> b -> b) -> Joker g a a0 -> b Source #

(Foldable1 f, Foldable1 g) => Foldable1 (f :.: g) | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => (f :.: g) m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> (f :.: g) a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> (f :.: g) a -> m Source #

toNonEmpty :: (f :.: g) a -> NonEmpty a Source #

maximum :: Ord a => (f :.: g) a -> a Source #

minimum :: Ord a => (f :.: g) a -> a Source #

head :: (f :.: g) a -> a Source #

last :: (f :.: g) a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> (f :.: g) a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> (f :.: g) a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> (f :.: g) a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> (f :.: g) a -> b Source #

Foldable1 f => Foldable1 (M1 i c f) | Since: base-4.18.0.0

Instance details

Defined in Data.Foldable1

Methods

fold1 :: Semigroup m => M1 i c f m -> m Source #

foldMap1 :: Semigroup m => (a -> m) -> M1 i c f a -> m Source #

foldMap1' :: Semigroup m => (a -> m) -> M1 i c f a -> m Source #

toNonEmpty :: M1 i c f a -> NonEmpty a Source #

maximum :: Ord a => M1 i c f a -> a Source #

minimum :: Ord a => M1 i c f a -> a Source #

head :: M1 i c f a -> a Source #

last :: M1 i c f a -> a Source #

foldrMap1 :: (a -> b) -> (a -> b -> b) -> M1 i c f a -> b Source #

foldlMap1' :: (a -> b) -> (b -> a -> b) -> M1 i c f a -> b Source #

foldlMap1 :: (a -> b) -> (b -> a -> b) -> M1 i c f a -> b Source #

foldrMap1' :: (a -> b) -> (a -> b -> b) -> M1 i c f a -> b Source #

intercalate1 :: (Foldable1 t, Semigroup m) => m -> t m -> m Source #

Insert an `m` between each pair of `t m`.

    >>> intercalate1 ", " $ "hello" :| ["how", "are", "you"]
    "hello, how, are, you"

    >>> intercalate1 ", " $ "hello" :| []
    "hello"

    >>> intercalate1 mempty $ "I" :| ["Am", "Fine", "You?"]
    "IAmFineYou?"

Since: base-4.18.0.0

foldrM1 :: (Foldable1 t, Monad m) => (a -> a -> m a) -> t a -> m a Source #

Monadic fold over the elements of a non-empty structure, associating to the right, i.e. from right to left.

Since: base-4.18.0.0

foldlM1 :: (Foldable1 t, Monad m) => (a -> a -> m a) -> t a -> m a Source #

Monadic fold over the elements of a non-empty structure, associating to the left, i.e. from left to right.

Since: base-4.18.0.0

intercalateMap1 :: (Foldable1 t, Semigroup m) => m -> (a -> m) -> t a -> m Source #

Insert `m` between each pair of `m` derived from `a`.

    >>> intercalateMap1 " " show $ True :| [False, True]
    "True False True"

    >>> intercalateMap1 " " show $ True :| []
    "True"

traverse1_ :: (Foldable1 t, Apply f) => (a -> f b) -> t a -> f () Source #

for1_ :: (Foldable1 t, Apply f) => t a -> (a -> f b) -> f () Source #

sequenceA1_ :: (Foldable1 t, Apply f) => t (f a) -> f () Source #

foldMapDefault1 :: (Foldable1 t, Monoid m) => (a -> m) -> t a -> m Source #

Usable default for foldMap, but only if you define foldMap1 yourself

asum1 :: (Foldable1 t, Alt m) => t (m a) -> m a Source #

gfold1 :: (Foldable1 (Rep1 t), Generic1 t, Semigroup m) => t m -> m Source #

Generic `fold1`. Caveats:

1. Will not compile if `t` is an empty constructor.
2. Will not compile if `t` has some fields that don't mention `a`, for exmaple `data Bar a = MkBar a Int`

Since: 5.3.8

gfoldMap1 :: (Foldable1 (Rep1 t), Generic1 t, Semigroup m) => (a -> m) -> t a -> m Source #

Generic `foldMap1`. Caveats are the same as for `gfold1`.

Since: 5.3.8

gtoNonEmpty :: (Foldable1 (Rep1 t), Generic1 t) => t a -> NonEmpty a Source #

Generic `toNonEmpty`. Caveats are the same as for `gfold1`.

Since: 5.3.8